#include once "common.bi"
#include once "srb.bi"
#include once "aspi.bi"
#include once "cdrom.bi"
#include once "cddb.bi"
#include once "freedb.bi"

'' --------------------------------------------------------

dim no_query as integer = FALSE
dim ret as integer = FALSE
dim opt_outdir as string = ""
dim opt_help as integer = FALSE

dim i as integer = 1
while command(i) > ""

	select case command(i)
	case "-h"
		opt_help = TRUE

	case "-o"
		i += 1
		opt_outdir = command(i)

	case "-n"
		no_query = TRUE

	end select
	i += 1

wend

if( opt_help ) then
	print "cddir_xp [-n] [-o out_dir]"
	print
	print "   -n                no query, don't connect to freedb"
	print "   -o out_dir        write cddb records to out_dir"
	print
	end
end if

print "Loading ASPI DLL ... ";
if( ASPI_Init() = FALSE ) then
	print "Failed"
	end 1
else
	print "OK"
end if

print "Getting ASPI info ... ";

if( ASPI_GetInfo() ) then
	print "OK - ";
	print "Found " & aspi.adaptercount & " adapters"
else
	print "Failed"
end if

if( aspi.status = SS_COMP ) then

	CDROM_ScanDevices()
	if( CDROM_ReadTOCByIndex( 0 ) ) then
		CDROM_ListTOC()
		print "DISCID = " & lcase(hex(CDROM_get_cddb_discid(),8))
		print
		print CDROM_get_cddb_query_string()

		if( no_query = FALSE ) then
			ret = FREEDB_GetDiscography( opt_outdir & "discid" )
		end if
	else
		print "Unable to read TOC"
	end if
else
	print ASPI_GetErrorMsg( aspi.status )

end if

ASPI_Exit()

if ret = FALSE then
	end 1
end if
