#include once "windows.bi"

#include once "cdrom_ioctl.bi"

function CDROM_ReadSectors _
	( _
		byval iDevice as integer, _
		byval iStartSector as integer, _
		byval iEndSector as integer, _
		byval buffer as ubyte ptr _
	) as integer
	
end function

function CDROM_ComputeBufferLength _
	( _
		byval iDevice as integer, _
		byval iStartSector as integer, _
		byval iEndSector as integer _
	) as integer

end function

''
function CDROM_LockDisk _
	( _
		byval hCD as HANDLE _
	) as integer

	dim as PREVENT_MEDIA_REMOVAL pmrLockCDROM
	dim as DWORD   dwNotUsed

	pmrLockCDROM.PreventMediaRemoval = TRUE

	function = DeviceIoControl( hCD, IOCTL_CDROM_MEDIA_REMOVAL, _
		@pmrLockCDROM, sizeof(pmrLockCDROM), NULL, _
		0, @dwNotUsed, NULL )

end function

''
function CDROM_UnlockDisk _
	( _
		byval hCD as HANDLE _
	) as integer

	dim as PREVENT_MEDIA_REMOVAL pmrLockCDROM
	dim as DWORD   dwNotUsed

	pmrLockCDROM.PreventMediaRemoval = FALSE

	function = DeviceIoControl( hCD, IOCTL_CDROM_MEDIA_REMOVAL, _
		@pmrLockCDROM, sizeof(pmrLockCDROM), NULL, _
		0, @dwNotUsed, NULL )

end function

''
sub CDROM_RipTest()

	dim as integer iStartSector = 300
	dim as integer iSectorCount = 1000


	dim as HANDLE  hCD, hFile
	dim as DWORD   dwNotUsed

	hFile = CreateFile ( "sector.dat", _
						GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, _
						FILE_ATTRIBUTE_NORMAL, NULL)

	hCD = CreateFile ( !"\\\\.\\Q:", GENERIC_READ, _
						FILE_SHARE_READ or FILE_SHARE_WRITE, _
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, _
						NULL)

	if( hCD <> INVALID_HANDLE_VALUE ) then

		dim as DISK_GEOMETRY dgCDROM

		CDROM_LockDisk( hCD )

		if( DeviceIoControl( hCD, IOCTL_CDROM_GET_DRIVE_GEOMETRY, _
			NULL, 0, @dgCDROM, sizeof(dgCDROM), _
			@dwNotUsed, NULL) ) then

			dim as LPBYTE lpSector
			dim as DWORD  dwSize = iSectorCount * dgCDROM.BytesPerSector

			print "Bytes per sector = " & dgCDROM.BytesPerSector

			lpSector = VirtualAlloc( NULL, dwSize, _
				MEM_COMMIT or MEM_RESERVE, _
				PAGE_READWRITE )

			SetFilePointer( hCD, dgCDROM.BytesPerSector * iStartSector, _
				NULL, FILE_BEGIN )

			print "Bytes to read = " & dwSize
			if( ReadFile( hCD, lpSector, dwSize, @dwNotUsed, NULL )) then
				print "Bytes read = " & @dwNotUsed
				WriteFile( hFile, lpSector, dwSize, @dwNotUsed, NULL )
			else
				print "Read failed."
			end if

			VirtualFree( lpSector, 0, MEM_RELEASE )

		end if

		CDROM_UnlockDisk( hCD )

		CloseHandle (hCD)
		CloseHandle (hFile)

	end if

end sub


