#include once "logtool.bi"

dim shared filename as string
dim shared filehandle as integer
dim shared msglevel as integer
dim shared msg_cb as LOGCALLBACK

''
sub LogSetFileName( byref s as const string )
	filename = s
end sub

''
function LogGetFileName() as string
	function = filename
end function

''
sub LogSetMsgLevel( byval level as LogMsgLevel )
	if( level < 0 ) then
		msglevel = 0
	elseif( level > LOGMSGLEVEL_DEBUG ) then
		msglevel = LOGMSGLEVEL_DEBUG
	else
		msglevel = level
	end if
end sub

''
function LogGetMsgLevel() as LogMsgLevel
	function = msglevel
end function

''
function LogOpen() as integer
	if( filehandle ) then
		close #filehandle
	end if
	filehandle = freefile
	if( open( filename for append as #filehandle ) = 0 ) then
		function = 1
	else
		filehandle = 0
		function = 0
	end if
end function

''
sub LogClose()
	if( filehandle ) then
		close #filehandle
		filehandle = 0
	end if
end sub

''
sub LogMsg( byref s as const string, byval level as LogMsgLevel = LOGMSGLEVEL_INFO )
	if( level >= msglevel ) then
		if( filehandle ) then
			print #filehandle, s	
		elseif( msg_cb ) then
			msg_cb( strptr(s) )
		else
			print s
		end if
	end if
end sub

''
sub LogSetCallBack( byval p as LOGCALLBACK )
	msg_cb = p
end sub
