#include once "windows.bi"
#include once "win/winsock2.bi"
#include once "logtool.bi"
#include once "sockerr.bi"
#include once "socktool.bi"
#include once "telnet.bi"

#define length(_x) LEN((_x))

const CRLF = chr(13,10)

dim shared telnet_buffer as string

''
function TELNET_send _
	( _
		byval s as SOCKET, _
		byref cmd as string _
	) as integer

	send( s, strptr(cmd), length(cmd), 0 )

	function = 0

end function

''
function TELNET_recv _
	( _
		byval s as SOCKET _
	) as integer

	dim ret as integer
	dim response as string
	dim buffer as zstring * 2048
	dim text as string

	function = -1

	do
		'' wait for a response
		dim as fd_set r, w, x
		dim as timeval t = ( 5, 0 )

		FD_ZERO( @r ) : FD_ZERO( @w ) : FD_ZERO( @x )
		FD_SET_( s, @r ) : FD_SET_( s, @x )
		ret = select_( 0, @r, @w, @x, @t )

		if( ret = SOCKET_ERROR ) then
			ShowSocketError("select()")
			exit do

		elseif( ret = 0 ) then
			logmsg( "Timed out waiting for a response" )
			exit do

		else
			ret = recv( s, cast(ubyte ptr, @buffer), 2048, 0 )

			if( ret = INVALID_SOCKET ) then
				ShowSocketError("recv()")
				exit do
			
			elseif( ret > 0 ) then

				text = left( buffer, ret )
				telnet_buffer += text
			
				function = length(text)
			
				exit do

			end if
		end if

	loop

end function

''
function TELNET_readline _
	( _
		byval s as SOCKET, _
		byref text as string _
	) as integer

	dim i as integer

	do
		i = instr( telnet_buffer, CRLF )
		if( i > 0 ) then
			function = i - 1
			text = left( telnet_buffer, i - 1 )
			telnet_buffer = mid( telnet_buffer, i + 2 )
			exit do
		else
			if( TELNET_recv( s ) < 0 ) then
				exit do
			end if
		end if
	loop

end function
